#!/bin/env python

import signal, os, time, resource

def handler(signum, frame):
    print 'Good. I just received signal %d. Proceed to step step 2 to subvert this program\'s signal handler.' % signum

signal.signal(signal.SIGABRT, handler)

resource.setrlimit(resource.RLIMIT_CORE, (-1, -1))
pid = os.getpid()

print """Instructions:
1. Send a SIGABRT signal to this program via: kill -ABRT %d
2. After you have tested this signal handler, strip the signal handler via: echo %d > /proc/stripsignal_pid
3. Finally send the signal once more and verify a corefile is written out.
   I have just set the RLIMIT for core to "unlimited".
   So once I receive the signal again a core file will be written out instead.
""" % (pid, pid)

while True:
    time.sleep(1)
    
